From e7a11784e9a0fbb82fd628d2363c6eaa4bcec1bd Mon Sep 17 00:00:00 2001
From: Peter Pentchev <roam@ringlet.net>
Date: Wed, 9 Mar 2011 19:50:56 +0200
Subject: [PATCH 16/16] Fix an undefined order of operations problem.

---
 debian/patches/hardening.patch |   13 +++++++++++++
 1 files changed, 13 insertions(+), 0 deletions(-)

diff --git a/debian/patches/hardening.patch b/debian/patches/hardening.patch
index eb8fb9c..a392eaa 100644
--- a/debian/patches/hardening.patch
+++ b/debian/patches/hardening.patch
@@ -1,6 +1,7 @@
 Description: Harden the build.
  - check the fread() and fwrite() return values
  - swap a return and an fclose()
+ - fix an undefined order of operations problem
 Forwarded: no
 Author: Peter Pentchev <roam@ringlet.net>
 Last-Update: 2011-03-07
@@ -152,3 +153,15 @@ Last-Update: 2011-03-07
  
  	// close file
  	fclose(fp);
+--- a/src/shooter.c
++++ b/src/shooter.c
+@@ -903,7 +903,8 @@
+ 									s_var.score += 1000000;
+ 								}
+ 								else {  // increase power
+-									s_var.power_level = MIN(s_var.power_level ++, 7);
++									if (++s_var.power_level > 7)
++										s_var.power_level = 7;
+ 								}
+ 								play_sound_id(SMPL_HEART);	
+ 
-- 
1.7.2.3

